<?php 

// much of this is borrowed from OsCommerce PHPlist Newsletter add-on
// here's the stuff from that file...
/*
  $Id: PHPlist_mod_osCommerce v0.6, 2005-11-30

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  PHPlist, Open Source Newsletter Solution
  http://www.phplist.com

  Copyright (c) 2005 jgeesey (JPG), Thomas Arnqvist

  Released under the GNU General Public License
*/

// Modified for PHPLIST+Magento by David Heath-Whyte, July 2011
// Maynard's Groovy Bible Tunes www.maynardsgroovytunes.co.uk

require_once 'MGBT_phplist_define.php'; //get the phplist specifics
include_once 'MGBT_database.php';		// get the OsCommerce database functions

function MGBT_phplist_subscribe($email_address, $customer_id, $firstname, $lastname){

	// connect to the database
	tep_db_connect('localhost', PHPLIST_DB_USER, PHPLIST_DB_PASSWORD, PHPLIST_DB);
	
	//get user specifics from PHPlist
	$existing_email_query = tep_db_query("select id, email, foreignkey from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user where email = '" . $email_address . "'"); //check for existing by email address
	$history_systeminfo_text = "\nHTTP_USER_AGENT = " . $_SERVER["HTTP_USER_AGENT"] ."\nHTTP_REFERER = " . $_SERVER["HTTP_REFERER"] . "\nREMOTE_ADDR = " . $_SERVER["REMOTE_ADDR"] . "";
	$history_detail_text = "";
	
	if (tep_db_num_rows($existing_email_query) < 1) { //no existing user by email address found (therefore a new user - no id or email found)
		$id = md5(uniqid(mt_rand())); //generate unique id and add new user to database
		tep_db_query("insert into " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user (email, confirmed, subscribepage, entered, modified, disabled, uniqid, htmlemail, foreignkey) values ('" . $email_address . "', 1, " . PHPLIST_SPAGE . ", now(), now(), 0, '" . $id . "', " . PHPLIST_HTMLEMAIL . ", " . $customer_id . ")"); //insert the new user into phplist
		$user_query=tep_db_query("select id from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user where email = '" . $email_address . "'"); //get the new user's phplist id
		$user = tep_db_fetch_array($user_query);
		if (PHPLIST_FIRSTNAME != '') tep_db_query("insert into " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user_attribute (attributeid, userid, value) values (" . PHPLIST_FIRSTNAME . ", " . $user['id'] . ", '" . $firstname . "')"); //add the users firstname to the attributes table 
		if (PHPLIST_LASTNAME != '') tep_db_query("insert into " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user_attribute (attributeid, userid, value) values (" . PHPLIST_LASTNAME . ", " . $user['id'] . ", '" . $lastname . "')"); //add the users lastname to the attributes table
		tep_db_query("insert into " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser (userid, listid, entered) values (" . $user['id'] . ", " . PHPLIST_LISTNO . ", now())"); //subscribe the new user to the correct list
		//generating history
		$history_detail_text .= "\nSubscribepage = " . PHPLIST_SPAGE . "\nforeign key = " . $customer_id . "\n";
		if (PHPLIST_FIRSTNAME != '') {
			$attribute_name_query = tep_db_query("select name from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_attribute where id = " . PHPLIST_FIRSTNAME . "");
			$attribute_name = tep_db_fetch_array($attribute_name_query);
			$history_detail_text .= "" . $attribute_name[name] . " = " . $firstname . "\n";
		}
		if (PHPLIST_LASTNAME != '') {
			$attribute_name_query = tep_db_query("select name from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_attribute where id = " . PHPLIST_LASTNAME . "");
			$attribute_name = tep_db_fetch_array($attribute_name_query);
			$history_detail_text .= "" . $attribute_name[name] . " = " . $lastname . "\n";
		}
		$list_name_query = tep_db_query("select name from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "list where id = " . PHPLIST_LISTNO . "");
		$list_name = tep_db_fetch_array($list_name_query);
		$history_detail_text .= "\nList subscriptions:\n" . $list_name['name'] . "";
		tep_db_query("insert into " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user_history (userid, ip, date, summary, detail, systeminfo) values (" . $user['id'] . ", '" . $_SERVER["REMOTE_ADDR"] . "', '" . date('Y-m-d H:i:s') . "', 'Update through osC', '" . $history_detail_text . "', '" . $history_systeminfo_text . "')"); //create history post
	}
	else { //subscribe the existing user if disabled and add foreignkey match to customer_id
		$existing_email = tep_db_fetch_array($existing_email_query); //existing user by email found
		tep_db_query("update " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user set disabled = 0, confirmed = 1, foreignkey = " . $customer_id . " where id = " . $existing_email['id'] . "");
		$history_detail_text .= "foreign key = " . $customer_id . "\nchanged from ";
		//check to see if they already are subscribed to the correct list
		$list_query = tep_db_query("select * from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser where userid = " . $existing_email['id'] . " and listid = " . PHPLIST_LISTNO . "");
		if ($list=tep_db_num_rows($list_query) < 1) { //no existing subscription to the newsletter found
			//generating history, previous subscriptions
			$history_detail_text .= "\n\nList subscriptions:\n";
			$existing_subscription_query = tep_db_query("select li.name from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "list li, " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser lu where li.id = lu.listid and lu.userid = " . $existing_email['id'] . "");
			if (tep_db_num_rows($existing_subscription_query) < 1) {
				$history_detail_text .= "Was subscribed to: \n";
			} else {
				while($existing_subscription = tep_db_fetch_array($existing_subscription_query)){
				$history_detail_text .= "Was subscribed to: " . $existing_subscription[name] . "\n";
				}
			}
			tep_db_query("insert into " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser (userid, listid, entered) values (" . $existing_email['id'] . ", " . PHPLIST_LISTNO . ", now())"); //subscribe the new user to the correct list
			//generating history, current (updated) subscriptions
			$updated_subscription_query = tep_db_query("select li.name from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "list li, " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser lu where li.id = lu.listid and lu.userid = " . $existing_email['id'] . "");
			while ($updated_subscription = tep_db_fetch_array($updated_subscription_query)) {
				$history_detail_text .= "Is now subscribed to: " . $updated_subscription[name] . "\n";
			}
		}
		tep_db_query("insert into " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user_history (userid, ip, date, summary, detail, systeminfo) values (" . $existing_email['id'] . ", '" . $_SERVER["REMOTE_ADDR"] . "', '" . date('Y-m-d H:i:s') . "', 'Update through osC', '" . $history_detail_text . "', '" . $history_systeminfo_text . "')"); //create history post
	}
	tep_db_close();
}

function MGBT_phplist_unsubscribe($email_address, $customer_id) {
	
	// connect to the database
	tep_db_connect('localhost', PHPLIST_DB_USER, PHPLIST_DB_PASSWORD, PHPLIST_DB);
	
	//get user specifics from PHPlist
	$existing_email_query = tep_db_query("select id, email, foreignkey from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user where email = '" . $email_address . "'"); //check for existing by email address
	$history_systeminfo_text = "\nHTTP_USER_AGENT = " . $_SERVER["HTTP_USER_AGENT"] ."\nHTTP_REFERER = " . $_SERVER["HTTP_REFERER"] . "\nREMOTE_ADDR = " . $_SERVER["REMOTE_ADDR"] . "";
	$history_detail_text = "";

	if (tep_db_num_rows($existing_email_query) > 0 ) {
		$history_detail_text = "\n";
		$existing_email = tep_db_fetch_array($existing_email_query);
		tep_db_query("update " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user set foreignkey = " . $customer_id . " where email = '" . $email_address . "'"); //change the foreignkey to match the customer_id
		$history_detail_text = "foreign key = " . $customer_id . "\nchanged from \n\n";
		//generating history, previous subscriptions
		$existing_subscription_query = tep_db_query("select li.name from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "list li, " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser lu where li.id = lu.listid and lu.userid = " . $existing_email['id'] . "");
		$history_detail_text .= "List subscriptions:\n";
		while($existing_subscription = tep_db_fetch_array($existing_subscription_query)) {
			$history_detail_text .= "Was subscribed to: " . $existing_subscription[name] . "\n";
		}
		tep_db_query("delete from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser where listid = " . PHPLIST_LISTNO . " and userid = " . $existing_email['id'] . "");
		//generating history, current (updated) subscriptions
		$updated_subscription_query = tep_db_query("select li.name from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "list li, " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser lu where li.id = lu.listid and lu.userid = " . $existing_email['id'] . "");
		if (tep_db_num_rows($updated_subscription_query) < 1) {
			$history_detail_text .= "Not subscribed to any lists\n";
		} 
		else {
			while($updated_subscription = tep_db_fetch_array($updated_subscription_query)) {
				$history_detail_text .= "Is now subscribed to: " . $updated_subscription[name] . "\n";
			}
		}
		tep_db_query("insert into " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user_history (userid, ip, date, summary, detail, systeminfo) values (" . $existing_email['id'] . ", '" . $_SERVER["REMOTE_ADDR"] . "', '" . date('Y-m-d H:i:s') . "', 'Update through osC', '" . $history_detail_text . "', '" . $history_systeminfo_text . "')"); //create history post
	}
	tep_db_close();	
}

function MGBT_phplist_checksubscribed($email_address) {
	
	// connect to the database
	tep_db_connect('localhost', PHPLIST_DB_USER, PHPLIST_DB_PASSWORD, PHPLIST_DB);
	
	//get user specifics from PHPlist
	$existing_email_query = tep_db_query("select id, email, foreignkey, disabled from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "user_user where email = '" . $email_address . "'"); //check for existing by email address
	$result = false;
	if (tep_db_num_rows($existing_email_query) > 0) {
		$existing_email = tep_db_fetch_array($existing_email_query);
		//if ($existing_email['disabled'])
		$list_query = tep_db_query("select * from " . PHPLIST_DB . "" . PHPLIST_TABLE_PREFIX . "listuser where userid = " . $existing_email['id'] . " and listid = " . PHPLIST_LISTNO . "");
		if ($list=tep_db_num_rows($list_query) > 0) { //no existing subscription to the newsletter found
			$result = true;
		}
	}
	tep_db_close();
	return $result;
}

?>